;_______________________ MLO-Hotkeys _________________________
;__________ Autohotkey Scripts for MyLife Organized __________
;_____________  http://www.mylifeorganized.net/  _____________
;_______________  http://www.autohotkey.com  _________________
;______________________  Jon Rumens  _________________________
;*************************************************************
;*************************************************************

ScriptName =  MLO-Hotkeys
TrayName = MLO-Hotkeys
AppName = MLO-Hotkeys
Version = 1.82
BuildDate = 2010-07-31

SendMode Input
;#notrayicon
#SingleInstance Force
#Persistent
#WinActivateForce
#UseHook  ; Force the use of the hook for hotkeys after this point.

SetBatchLines -1
Process Priority,,AboveNormal
SetWorkingDir, %A_ScriptDir%

RegRead, AHKPath, HKEY_LOCAL_MACHINE, SOFTWARE\AutoHotkey,InstallDir

IniFile=%A_ScriptDir%\%ScriptName%.ini


; Check whether it is my computer because if it is I want to change some hotkeys
; because I have a different keyboard layout (Colemak) and also I do some extra backups.
IfEqual, A_ComputerName, JONPC
	JonsComputer = 1
Else IfEqual, A_ComputerName, JON-PC
		JonsComputer = 1
Else IfEqual, A_ComputerName, JONLT
		JonsComputer = 1
Else
	JonsComputer = 0

If JonsComputer
{
	BackupName = %A_YYYY%%A_MM%%A_DD%-%A_HOUR%%A_MIN%
	BackupDir = C:\Backup\AHK
	FileCreateDir, %BackupDir%
}

;Some 'Constants' which I use.

	30secs := 30000
	1min := 60000
	2mins := 120000
	5mins := 300000
	10mins := 600000
	15mins := 3600000/4
	20mins := 3600000/3
	30mins := 3600000/2
	1hr := 3600000
	2hrs := 3600000*2
	3hrs := 3600000*3	
	4hrs := 3600000*4

;For SetTitleMatchMode
start = 1
contain = 2
exact = 3
blank =

Gosub, IniRead

;**************************************************************************************
;**************************************************************************************
;**************************************************************************************

;Global Hotkeys

Hotkey, %hk_RapidTaskEntry%, RapidTaskEntry
Hotkey, %hk_ToggleMLO%, ToggleMLO
Hotkey, %hk_SnippetToTask%, SnippetToTask
Hotkey, %hk_FavouriteParents%, FavouriteParents

;**************************************************************************************

;Context Sensitive Hotkeys for MLO Main Window

Hotkey, IfWinActive, ahk_class TfrmMyLifeMain

Hotkey, %hk_CollapseExpandOutline%, CollapseExpandOutline
Hotkey, %hk_ExpandFirstLevelOutline%, ExpandFirstLevelOutline
Hotkey, %hk_ToggleNotesProperties%, ToggleNotesProperties
Hotkey, %hk_ToggleContexts%, ToggleContexts
Hotkey, %hk_ToggleZoom%, ToggleZoom

Hotkey, %hk_DueToday%, DueToday
Hotkey, %hk_DueTomo%, DueTomo
Hotkey, %hk_Due2Days%, Due2Days
Hotkey, %hk_Due3Days%, Due3Days
Hotkey, %hk_Due4Days%, Due4Days
Hotkey, %hk_Due5Days%, Due5Days
Hotkey, %hk_Due6Days%, Due6Days
Hotkey, %hk_Due7Days%, Due7Days
Hotkey, %hk_DueMonth%, DueMonth
;Hotkey, %hk_DueFriday%, DueFriday
Hotkey, %hk_DueSunday%, DueSunday
;Hotkey, %hk_DueNextFriday%, DueNextFriday
;Hotkey, %hk_DueNextSunday%, DueNextSunday

Hotkey, %hk_PartialCompleteTask%, PartialCompleteTask
Hotkey, %hk_DetachRecurrentTask%, DetachRecurrentTask
Hotkey, %hk_CompletedYesterday1%, CompletedYesterday
Hotkey, %hk_DueTodayThenComplete%, DueTodayThenComplete
Hotkey, ~LButton & RButton, ShowContextMenu
Hotkey, Ctrl & RButton, ShowContextMenu
Hotkey, %hk_DecreaseDue%, DecreaseDue
Hotkey, %hk_IncreaseDue%, IncreaseDue
Hotkey, %hk_DecreaseStart%, DecreaseStart
Hotkey, %hk_IncreaseStart%, IncreaseStart
Hotkey, %hk_SelectContexts1% & %hk_SelectContexts2%, SelectContexts
Hotkey, %hk_SelectContexts2% & %hk_SelectContexts1%, SelectContexts
;Hotkey, %hk_ViewUp%, ViewUp
;Hotkey, %hk_ViewDown%, ViewDown

Hotkey, %hk_PasteFileLinks%, PasteFileLinks

Hotkey, IfWinActive

;**************************************************************************************

;Context Sensitive Hotkeys for MLO Contexts Window

Hotkey, IfWinActive, ahk_class TfrmContextEditFrm

Hotkey, %hk_ToggleContexts%, ToggleContexts

Hotkey, IfWinActive

;**************************************************************************************

;Context Sensitive Hotkeys for MLO Reminder Window

Hotkey, IfWinActive, ahk_class TfrmRemindersWnd



Hotkey, IfWinActive

;**************************************************************************************

Gosub, GetDates
SetTimer, GetDates, %1hr%
SetTimer, CheckReload, 2000
SetTimer, DialogHandler, %DialogHandlerDelay%
SetTimer, Scheduler, 5000
ifequal, UpdateCheck, 1
	SetTimer, UpdateCheck, %1hr%

;Sub Routines
Gosub, PrepareTray
Gosub, SettingsMenuChecker

OnExit, ExitSub


Return ;End of Auto-execute Section

;**************************************************************************************
;**************************************************************************************
;Hotkey Labels
;**************************************************************************************

PasteFileLinks:
	KeyWait, Shift
	KeyWait, ctrl
	ClipSaved := ClipboardAll   ; Save the entire clipboard to a variable of your choice.

	StringReplace,clipboard,clipboard,%A_Space%,`%20, All
	StringSplit, file, clipboard, `n, .  ; Omits periods.
	Loop, %file0%
	{
	  clipboard :=
		clipboard := file%a_index%
		;clipwait, 3
		clipboard = file://%clipboard%
		sleep, 20
		Send, ^v
		;send, %clipboard%
		Send, {Enter}{Enter}
	}

	Clipboard := ClipSaved   ; Restore the original clipboard. Note the use of Clipboard (not ClipboardAll).
	ClipSaved =   ; Free the memory in case the clipboard was very large.

Return

FavouriteParents:

	Menu, Favs, add, %A_thislabel%, dummy
	Menu, Favs, disable, %A_thislabel%
	Menu, Favs, add
	path1 = 
	loop, %NumFavs%
		{
			thispath := Fav%a_index%
			Menu, Favs, add, %thispath%, FavouriteParentsMenu
	  }

	Menu, Favs, show
	Menu, Favs, Delete
	
	ifequal, path1, %blank%
	return
	 
	StringTrimLeft, path1, path1, 1 ;get rid of first backslash
	;StringTrimRight, path1, path1, 1 ;get rid of last backslash

	StringSplit, pathArray, path1, `\ ;split the path into an array

	gosub, RapidTaskEntry
	control, check,,TCheckBox2,Rapid Task Entry
	send, !p ;open select task window
	winwaitactive, ahk_class TfrmSelectTaskNode
	;msgbox, %pathArray0% %pathArray1% %pathArray2%
	send, {home} ;go to top of select task list
	;sleep 200
	Loop, %pathArray0% ;send the path one by one
	{
	    thistask := pathArray%a_index%
	 		; msgbox,%thistask%
	    send, %thistask%
	    send, {left}{right}
	}
	send, {enter}
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
		settimer, TrayTipOff, 2000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
return


CheckMLOvis:
	WinGet, MLOStyle, Style, ahk_class TfrmMyLifeMain
	WinGet, MLOState,MinMax, ahk_class TfrmMyLifeMain
	Transform, MLOVis, BitAnd, %MLOStyle%, 0x10000000 ; 0x10000000 is WS_Visible.
return

ToggleMLO:
	gosub, CheckMLOvis
	DetectHiddenWindows, on
	IfWinNotExist, ahk_class TfrmMyLifeMain
	{
		Run, %MLOFileDir%\%MLOMainFile%
		WinActivate, ahk_class TfrmMyLifeMain
		WinWaitActive, ahk_class TfrmMyLifeMain,, 4
		collapsed = 0
		Gosub, CollapseExpandOutline
	}
	Else IfGreaterOrEqual, MLOState, 0
			WinMinimize
	Else
		Send, %MLOsOpenHotkey%
Return


RapidTaskEntry:
	settitlematchmode, %start%
	MouseGetPos, mX, mY
	WinGet, QuickAddStyle, Style, ahk_class TfrmQuickAddMLOTask
	Transform, QuickAddVis, BitAnd, %QuickAddStyle%, 0x10000000 ; 0x10000000 is WS_Visible.
	DetectHiddenWindows, on
	IfWinNotExist, ahk_class TfrmMyLifeMain
	{
		WinGet, active_id, ID, A
		Run, %MLOFileDir%\%MLOMainFile%
		WinWaitActive, ahk_class TfrmMyLifeMain,, 4
		WinMinimize
		WinActivate, ahk_id %active_id%
		Send, %MLOsRapidTaskHotkey%
	}
	Else If QuickAddVis  ;is Visible
	{
		WinClose, ahk_class TfrmQuickAddMLOTask
		WinActivate, ahk_id %active_id%
	}
	Else ;not Visible
	{
		WinGet, active_id, ID, A
		Send, %MLOsRapidTaskHotkey%
		;winmove, Rapid Task Entry,, mX, mY
		sleep, 200
		;WinActivate, ahk_id %active_id%
	}
Return


SnippetToTask:

	settitlematchmode, %contain%
	WinGet, active_ID,ID, A
	WinGetTitle, active_title, A
	KeyWait, Alt
	KeyWait, ctrl
	ClipSaved := ClipboardAll   ; Save the entire clipboard to a variable of your choice.
; ... here make temporary use of the clipboard, such as for pasting Unicode text via Transform Unicode ...

	Clipboard =
  ;sleep 500
	Send, ^c
	Send, ^c
  ;sleep 500
	ClipWait,2
	;clipboard = %Clipboard%	; Convert to plain text.
	notes = %Clipboard%	; Convert to plain text.

  StringGetPos, pos, notes,`n
  StringLeft, TaskTitle, notes, pos
  StringTrimLeft, notes, notes, pos

	StringGetPos, pos, notes,Why is this spam/non-spam?
	if pos >= 0
	{
	  StringTrimLeft, notes, notes, pos
		StringReplace,notes,notes,Why is this spam/non-spam?,,
	}

	ifequal, TaskTitle, %blank%
	{
		TaskTitle = %notes%
		notes =
		}
	else
	notes = %TaskTitle%`n%notes%
  ;msgbox, %notes%
	
	;TaskTitle = %active_title%
	
	ifwinactive, Firefox
	{
	 ifwinactive, Mail
	  TaskTitle = %active_title%
	  ;temp = %Clipboard%
		send, !d
		sleep, 100
		Clipboard =
		send, ^c
		ClipWait,5,1
		URL = %clipboard%
		;clipboard := temp
		;ClipWait,5,1
		;msgbox,%temp% %clipboard% %URL%
	}
	else ifwinactive, CoolNovo
	{
	 ifwinactive, Mail
	  TaskTitle = %active_title%
	  ;temp = %Clipboard%
		send, !d
		sleep, 200
		Clipboard =
		send, ^c
		ClipWait,5,1
		URL = %clipboard%
		;clipboard := temp
		;ClipWait,5,1
		;msgbox,%temp% %clipboard% %URL%
	}
	else
		URL =
    
	IfWinNotExist, ahk_class TfrmMyLifeMain
	{
		Run, %MLOFileDir%\%MLOMainFile%
		WinActivate, ahk_class TfrmMyLifeMain
		WinWaitActive, ahk_class TfrmMyLifeMain,, 4
	}
	WinActivate, ahk_class TfrmMyLifeMain
	ifwinactive, ahk_class TfrmMyLifeMain
	{
	gosub, CheckIfToDoActive
	
	Send, !o{home}
	send, %SnippetTaskName%
	send, !{Insert} ;go to outline and create new task
	;StringLeft, TaskTitle, clipboard, 30  ; Stores the string "This" in OutputVar.
	ifequal, TaskTitle, %blank%
		TaskTitle = %notes%
	clipboard = %TaskTitle%
		ClipWait,5,1
	send, ^v{enter}
	send, !1
	sleep 500
		;msgbox,%temp% %clipboard% %URL%
	ifnotequal, URL, %blank%
	{
	clipboard = %URL%
		ClipWait,5,1
	send, ^v
	sleep 100 ;wait for paste
	send, `n`n
	}
	ifnotequal, notes, %blank%
	{
	clipboard = %notes%
		ClipWait,5,1
	send, ^v ;paste clipboard to notes
	}
	send, ^{home}!1
	If (ToDo = 1)
		Send, !t
	Sleep, 1000
	
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
		settimer, TrayTipOff, 1000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
	
	If RestoreWindowAfterSnippet
		WinActivate, ahk_id %active_ID% ;Return to the original window
	}

	Clipboard := ClipSaved   ; Restore the original clipboard. Note the use of Clipboard (not ClipboardAll).
	ClipSaved =   ; Free the memory in case the clipboard was very large.
Return

CheckIfToDoActive:
 	detecthiddentext, off
	settitlematchmode, %contain%
	ifwinexist,ml - MyLife Organized,&To-Do
 	ToDo = 1
	ifwinexist,ml - MyLife Organized,&Outline
 	ToDo = 0
return

CheckIfPropsActive:
 	detecthiddentext, off
	settitlematchmode, %contain%
	ifwinexist,ml - MyLife Organized,Properties
 	Props = 1
	ifwinexist,ml - MyLife Organized,Task Notes
 	Props = 0
return



SelectContexts:
		WinGet, active_id, ID, A
	Send, !l!{down}
	KeyWait %hk_SelectContexts1%
	KeyWait %hk_SelectContexts2%
	Send, {Enter}
	WinActivate, ahk_id %active_id%
	Send, !1
Return


;Expand/Collapse all items in my Outline
CollapseExpandOutline:
	If !collapsed
		Gosub, CollapseOutline
	Else
	{
		Send, !o{F7}{home}
		If JonsComputer
		{
			;collapse a few items at the botton and the top
			Send, mayb\
		  loop, 7
				send, {LEFT}{down}
			send, {HOME}{down}{left}{HOME}
		}
		collapsed = 0
	}
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
		settimer, TrayTipOff, 2000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
Return


ExpandFirstLevelOutline:
	If collapsed
	{
		;Send,!o^!r{F6}{END}
		Send,!o{F6}{END}
		Loop, %MaxItemsTopLevel%,
		{
			Send {Right}{UP}
		}
		collapsed = 0
	}
	Else
		Gosub, CollapseOutline
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 2000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
Return


CollapseOutline:
	;Send, !o^!r{F6}
	Send, !o{F6}
	collapsed = 1
Return


ToggleZoom:
	settitlematchmode, %contain%
	settitlematchmode, slow
	ifwinactive,MyLife Organized,Zoom to task
		send !%hk_ToggleZoom%
	else
		send %hk_ToggleZoom%
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 1000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
return


ToggleNotesProperties:
gosub, CheckIfPropsActive
SetDefaultMouseSpeed, 0
SetMouseDelay, 0
	MouseGetPos, origX, origY
	ControlGetPos, cX, cY,,, TPageControl1
	If (Props = 1)
	{
		MouseClick,left,(cX+30),(cY+10),,0
		Send, !1
	}
	Else
	{
		MouseClick,left,(cx+90),(cY+10),,0
	}
	MouseMove, origX, origY, 0
Return

ToggleNotesProperties2:
	MouseGetPos, origX, origY
	ControlGetPos, cX, cY,,, TPageControl1
	If ShowingProps
	{
		MouseClick,left,(cX+30),(cY+10),,0
		Send, !1
		ShowingProps = 0
	}
	Else
	{
		MouseClick,left,(cx+90),(cY+10),,0
		ShowingProps = 1
	}
	MouseMove, origX, origY, 0
Return

ToggleContexts:
ifwinactive, ahk_class TfrmContextEditFrm
winclose
else
		send {%hk_ToggleContexts%}
return

DueToday:
DueTomo:
Due2Days:
Due3Days:
Due4Days:
Due5Days:
Due6Days:
Due7Days:
DueMonth:
DueFriday:
DueSunday:
DueNextFriday:
DueNextSunday:
	;KeyWait, Alt
	;KeyWait, ctrl
	;DueTasksStartTodayModifier = Shift
	;msgbox %DueTasksStartTodayModifier%
	KeyIsDown := GetKeyState("Shift" [, "P"])
	StartToday := (DueTasksStartToday + KeyIsDown)

	;msgbox, %DueTasksStartToday% %KeyIsDown% %StartToday%
	date := %A_ThisLabel%
	If (DueTasksStartToday = 1)
		Send, !s ;Set Due Date
	Send, !d ;Set Due Date
	WinWaitActive, Task Recurrence,,0.5
	IfWinActive, Task Recurrence
	{
		Send, !u%date%
		Send, {Enter}
		WinWaitActive, ahk_class TfrmMyLifeMain,,0.9
	}
	Else
	{
		Send, !d{Delete}%date%
		if (StartToday = 1)
		{
			Send, !s{Delete}%DueToday%
			}
		else
			Send, !s{Delete}%date%
		Send, {Enter}
	}
	send !1
	
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 1000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
	
Return


PartialCompleteTask:
keywait Alt
gosub, CheckIfToDoActive
send ^{space}
Return

DetachRecurrentTask:
	KeyWait, Alt
	KeyWait, shift
	gosub, CheckIfToDoActive
	Send, !o
	Send, {esc}{space} ;complete the task
	Send, ^d ;duplicate
	Send, !e!e!o
	If (ToDo = 1)
	{
	 	sleep 1000
		Send, !t
	}
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 2000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
Return

DuplicateTask:
Send, ^d
return

;**************************************************************************************
;**************************************************************************************
;Context Sensitive Hotkeys for MLO Rapid Task Entry Dialog Only
;**************************************************************************************
#IfWinActive, ahk_class TfrmQuickAddMLOTask
Shift & Alt::
Alt & Shift::
LWin & Shift::

Send, !p
KeyWait Shift
Send, {Enter}{tab}

WinWaitClose, ahk_class TfrmSelectTaskNode
WinActivate ahk_class TfrmQuickAddMLOTask
WinWaitActive ahk_class TfrmQuickAddMLOTask

Return

Ctrl & Enter::
Alt & Enter::
KeyWait Alt
send, ^{enter}
WinActivate, ahk_id %active_id%
return

!f::gosub, FavouriteParents

:r*:@::
If JonsComputer
{
	SendRaw, Context ,
	Send, {BackSpace}
}
else
	SendRaw, @

Return

#IfWinActive
;**************************************************************************************

GetDates:
	FormatTime, DueToday, , ShortDate

	Yesterday =
	Yesterday += -1, days
	FormatTime, Yesterday, %Yesterday%, ShortDate

	DueTomo =
	DueTomo += 1, days
	FormatTime, DueTomo, %DueTomo%, ShortDate

	Due2Days =
	Due2Days += 2, days
	FormatTime, Due2Days, %Due2Days%, ShortDate
	Due3Days =
	Due3Days += 3, days
	FormatTime, Due3Days, %Due3Days%, ShortDate
	Due4Days =
	Due4Days += 4, days
	FormatTime, Due4Days, %Due4Days%, ShortDate
	Due5Days =
	Due5Days += 5, days
	FormatTime, Due5Days, %Due5Days%, ShortDate
	Due6Days =
	Due6Days += 6, days
	FormatTime, Due6Days, %Due6Days%, ShortDate
	Due7Days =
	Due7Days += 7, days
	FormatTime, Due7Days, %Due7Days%, ShortDate

	DueMonth =
	DueMonth += 30, days
	FormatTime, DueMonth, %DueMonth%, ShortDate

	DueFriday =
	DueFriday += 6, days
	DueFriday += -A_WDay, days
	FormatTime, DueFriday, %DueFriday%, ShortDate

	DueNextFriday =
	DueNextFriday += 6, days
	DueNextFriday += -A_WDay, days
	DueNextFriday += 7, days
	FormatTime, DueNextFriday, %DueNextFriday%, ShortDate

	DueSunday =
	DueSunday += 8, days
	DueSunday += -A_WDay, days
	FormatTime, DueSunday, %DueSunday%, ShortDate

	DueNextSunday =
	DueNextSunday += 8, days
	DueNextSunday += -A_WDay, days
	DueNextSunday += 7, days
	FormatTime, DueNextSunday, %DueNextSunday%, ShortDate

	;msgbox %Today% %Tomo%
	;FormatTime, Tomo, %Tomo%, ShortDate
Return


DecreaseDue:
IncreaseDue:
DecreaseStart:
IncreaseStart:
	KeyWait, alt
	WinWaitActive, ahk_class TfrmMyLifeMain
	gosub, CheckIfToDoActive
	gosub, CheckIfPropsActive
	ifinstring, a_thislabel, Start
		controlgettext, date, TCalendarChildEdit3
	ifinstring, a_thislabel, Due
		controlgettext, date, TCalendarChildEdit2

	Send, !d
	
	StringReplace,date,date,-,, All
	StringReplace,date,date,:,, All
	StringReplace,date,date,/,, All
	StringReplace,date,date,.,, All
	StringReplace,date,date,%A_Space%,, All
	ifinstring, a_thislabel, Increase
	date += 1, days
	ifinstring, a_thislabel, Decrease
	date += -1, days
	FormatTime, date,%date%, ShortDate
	WinWaitActive, Task Recurrence,,1.4
	IfWinActive, Task Recurrence
	{
		ifinstring, a_thislabel, Start
			Send, !s
		ifinstring, a_thislabel, Due
			Send, !u
	}
	else
	{
	  ifwinactive, ahk_class TfrmMyLifeMain
		ifinstring, a_thislabel, Start
			Send, !s
	}
  send, %date%
	IfWinActive, Task Recurrence
		send {enter}
	else
		send !1

	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 1000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
	
	If (ToDo = 1)
		Send, !t
	If (Props = 0)
		Send, !1
Return


CompletedYesterday:
	Send, !o
	Send, {esc}{Space}
	sleep, 200
	gosub, DecreaseDue
	gosub, DecreaseStart
	
	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 1000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}
Return

DueTodayThenComplete:
	KeyWait, alt
	WinWaitActive, ahk_class TfrmMyLifeMain
	gosub, CheckIfPropsActive
	If (Props = 0)
	{
		gosub, ToggleNotesProperties
		sleep 200
}
Send, !e!e
Sleep, 20
Send, !1
Send, {space}

	If (TrayNotifications = 1)
	{
		TrayTip,%TrayName%,%A_ThisLabel%
	settimer, TrayTipOff, 1000
	}
	If (ToolTips = 1)
	{
		ToolTip,%A_ThisLabel%
		settimer, ToolTipOff, 2000
	}

	If (Props = 0)
		gosub, ToggleNotesProperties
;Send, !1
return


SkipOccurence:
	send, !s
return

;Disabled as I sometimes delete tasks when I want to insert a child!
Alt & DEL::
Return



TryClk:
	If ( A_ThisHotkey = A_PriorHotkey and A_TimeSincePriorHotkey < DoubleClickSpeed )
		Count++
	Else Count=1
	Sleep 25
	SetTimer ClkChek, %DoubleClickSpeed%
Return

ClkChek:
	SetTimer ClkChek, Off
	IfEqual, Count, 1, Gosub, RapidTaskEntry
	IfEqual, Count, 2, Gosub, ToggleMLO
	;IfGreater, Count, 2, MsgBox %Count% Clicks. Mmm.. too many.
	Count=
Return


DialogHandler:
	IfEqual, DialogHandler, 1
	{
		KeyIsDown := GetKeyState("Shift" [, "P"])
		If KeyIsDown
			Return

		SetTitleMatchMode, %exact%
		DetectHiddenWindows, off
		DetectHiddenText, Off
		IfWinExist,Confirm - MyLife Organized,&Yes
			IfWinExist,Confirm - MyLife Organized,&No
			{
				;keywait Alt
				WinActivate
				Send, {Space}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
			}
		SetTitleMatchMode, %exact%
		DetectHiddenWindows, off
		DetectHiddenText, Off
		IfWinExist,Warning - MyLife Organized,&Yes
			IfWinExist,Warning - MyLife Organized,&No
			{
				;keywait Alt
				WinActivate
				Send, {Space}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
			}
		SetTitleMatchMode, %exact%
		DetectHiddenWindows, off
		DetectHiddenText, Off
		IfWinExist,Information - MyLife Organized,OK
			{
				;keywait Alt
				WinActivate
				Send, {Space}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
			}
		SetTitleMatchMode, %start%
		IfWinExist,Move task to new parent
		{
			WinActivate
			Send, {Enter}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}

		SetTitleMatchMode, %exact%
		IfWinExist,Relative or Absolute Path,Do not ask this again
		{
			WinActivate
			Send, {Enter}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}

		SetTitleMatchMode, %exact%
		IfWinExist,Skip occurrence
		{
			WinActivate
			Send, {Enter}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}

		SetTitleMatchMode, %start%
		DetectHiddenWindows, off
		DetectHiddenText, Off
		IfWinExist, Delete context
		{
			WinActivate
			Send, !d{Enter}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}

		SetTitleMatchMode, %start%
		DetectHiddenWindows, off
		DetectHiddenText, Off
		IfWinExist, Save Current View Settings
		{
		  If JonsComputer
			{
				WinActivate
				Send, {Enter}
			}
		}

		SetTitleMatchMode, %start%
		DetectHiddenWindows, off
		DetectHiddenText, Off
		IfWinExist, MyLife Organized,File not found: \\
		{
			WinActivate
			Send, {Enter}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}

		SetTitleMatchMode, slow
		DetectHiddenWindows, off
		DetectHiddenText, On
		IfWinExist, Sync,Error: File not found: \\
		{
			WinActivate
			Send, {space}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}
		SetTitleMatchMode, slow
		DetectHiddenWindows, off
		DetectHiddenText, On
		IfWinExist, MyLife Organized,Start sync transaction timeout
		{
			WinActivate
			Send, {space}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}
		SetTitleMatchMode, slow
		DetectHiddenWindows, off
		DetectHiddenText, On
		IfWinExist, MyLife Organized,Read Timeout.
		{
			WinActivate
			Send, {space}
				If (TrayNotifications = 1)
				{
					TrayTip,%TrayName%,%A_ThisLabel%
				settimer, TrayTipOff, 1000
				}
				If (ToolTips = 1)
				{
					ToolTip,%A_ThisLabel%
					settimer, ToolTipOff, 1000
				}
		}
	}
Return


IniRead:
	IniRead,DialogHandler,%IniFile%,Settings,DialogHandler,0
	IniRead,DialogHandlerDelay,%DialogHandlerDelay%,Settings,DialogHandlerDelay,400
	IniRead,Scheduler,%IniFile%,Settings,Scheduler,0
	IniRead,TrayNotifications,%IniFile%,Settings,TrayNotifications,1
	IniRead,Tooltips,%IniFile%,Settings,Tooltips,1
	IniRead,DoubleClickSpeed,%DoubleClickSpeed%,Settings,DoubleClickSpeed,450
	IniRead,MaxItemsTopLevel,%MaxItemsTopLevel%,Settings,MaxItemsTopLevel,12
	IniRead,DueTasksStartToday,%DueTasksStartToday%,Settings,DueTasksStartToday,1
	IniRead,RestoreWindowAfterSnippet,%RestoreWindowAfterSnippet%,Settings,RestoreWindowAfterSnippet,1
	IniRead,SnippetTaskName,%SnippetTaskName%,Settings,SnippetTaskName,<Inbox>
	IniRead,UpdateCheck,%UpdateCheck%,Settings,UpdateCheck,0

	IniRead,MLOFileDir,%IniFile%,Settings,MLOFileDir
	IniRead,MLOMainFile,%IniFile%,Settings,MLOMainFile
	IniRead,MLOFileList,%IniFile%,Settings,MLOFileList,Life.ml,2db.ml,MLO1.ml,MLO2.ml
	IniRead,MLOsOpenHotkey,%IniFile%,Settings,MLOsOpenHotkey,^+!1
	IniRead,MLOsRapidTaskHotkey,%IniFile%,Settings,MLOsRapidTaskHotkey,^+!2
	
	IniRead,hk_ToggleMLO,%IniFile%,Hotkeys,hk_ToggleMLO,#m
	IniRead,hk_RapidTaskEntry,%IniFile%,Hotkeys,hk_RapidTaskEntry,#n
	IniRead,hk_SnippetToTask,%IniFile%,Hotkeys,hk_SnippetToTask,!^c
	IniRead,hk_FavouriteParents,%IniFile%,Hotkeys,hk_FavouriteParents,#!n
	IniRead,hk_CollapseExpandOutline,%IniFile%,Hotkeys,hk_CollapseExpandOutline,!z
	IniRead,hk_ExpandFirstLevelOutline,%IniFile%,Hotkeys,hk_ExpandFirstLevelOutline,!x
	IniRead,hk_ToggleNotesProperties,%IniFile%,Hotkeys,hk_ToggleNotesProperties,!2
	IniRead,hk_ToggleZoom,%IniFile%,Hotkeys,hk_ToggleZoom,^r
	IniRead,hk_ToggleContexts,%IniFile%,Hotkeys,hk_ToggleContexts,F8
	IniRead,hk_SelectContexts1,%IniFile%,Hotkeys,hk_SelectContexts1,Ctrl
	IniRead,hk_SelectContexts2,%IniFile%,Hotkeys,hk_SelectContexts2,Shift
	IniRead,hk_ViewUp,%IniFile%,Hotkeys,hk_ViewUp,Ctrl & Up
	IniRead,hk_ViewDown,%IniFile%,Hotkeys,hk_ViewDown,Ctrl & Down
	IniRead,hk_PasteFileLinks,%IniFile%,Hotkeys,hk_PasteFileLinks,^+v

	;IniRead,DueTasksStartTodayModifier,%IniFile%,Hotkeys,DueTasksStartTodayModifier,Shift
	IniRead,hk_DueToday,%IniFile%,Hotkeys,hk_DueToday,Ctrl & *`
	IniRead,hk_DueTomo,%IniFile%,Hotkeys,hk_DueTomo,Ctrl & *1
	IniRead,hk_Due2Days,%IniFile%,Hotkeys,hk_Due2Days,Ctrl & *2
	IniRead,hk_Due3Days,%IniFile%,Hotkeys,hk_Due3Days,Ctrl & *3
	IniRead,hk_Due4Days,%IniFile%,Hotkeys,hk_Due4Days,Ctrl & *4
	IniRead,hk_Due5Days,%IniFile%,Hotkeys,hk_Due5Days,Ctrl & *5
	IniRead,hk_Due6Days,%IniFile%,Hotkeys,hk_Due6Days,Ctrl & *6
	IniRead,hk_Due7Days,%IniFile%,Hotkeys,hk_Due7Days,Ctrl & *7
	IniRead,hk_DueMonth,%IniFile%,Hotkeys,hk_DueMonth,Ctrl & *8
	IniRead,hk_DueFriday,%IniFile%,Hotkeys,hk_DueFriday,Ctrl & *f
	IniRead,hk_DueSunday,%IniFile%,Hotkeys,hk_DueSunday,Ctrl & *w
	IniRead,hk_DueNextFriday,%IniFile%,Hotkeys,hk_DueNextFriday,*^+f
	IniRead,hk_DueNextSunday,%IniFile%,Hotkeys,hk_DueNextSunday,*^+w
	
	hk_PartialCompleteTask =Alt & space
	hk_DuplicateTask =^d
	IniRead,hk_PartialCompleteTask,%IniFile%,Hotkeys,hk_PartialCompleteTask,Alt & space
	IniRead,hk_DetachRecurrentTask,%IniFile%,Hotkeys,hk_DetachRecurrentTask,!+d
	IniRead,hk_DueTodayThenComplete,%IniFile%,Hotkeys,hk_DueTodayThenComplete,!+t
	IniRead,hk_CompletedYesterday1,%IniFile%,Hotkeys,hk_CompletedYesterday1,!y
	IniRead,hk_SkipOccurence,%IniFile%,Hotkeys,hk_SkipOccurence,Alt & LButton
	IniRead,hk_DecreaseDue,%IniFile%,Hotkeys,hk_DecreaseDue,^Ctrl & -
	IniRead,hk_IncreaseDue,%IniFile%,Hotkeys,hk_IncreaseDue,Ctrl & =
	IniRead,hk_DecreaseStart,%IniFile%,Hotkeys,hk_DecreaseStart,Ctrl & [
	IniRead,hk_IncreaseStart,%IniFile%,Hotkeys,hk_IncreaseStart,Ctrl & ]

	ifequal,MLOFileDir,%blank%
		gosub, ReadReg
	ifequal,MLOMainFile,%blank%
		gosub, ReadReg
	IfNotExist,%MLOFileDir%\%MLOMainFile%
		gosub, ReadReg
		
	IniRead,NumSchedules,%IniFile%,Schedules,NumSchedules,0
	loop, %NumSchedules%
	{
		IniRead,Sched%a_index%,%IniFile%,Schedules,Sched%a_index%
	}

	IniRead,NumFavs,%IniFile%,FavouriteParents,NumFavs,0
	loop, %NumFavs%
	{
		IniRead,Fav%a_index%,%IniFile%,FavouriteParents,Fav%a_index%
	}
Return

ReadReg:
	 RegRead, LastDBFile, HKEY_CURRENT_USER, Software\MyLifeOrganized.net\MyLife\Settings,LastDBFile
	 ;SplitPath, FullFileName, name, dir, ext, name_no_ext, drive
	 SplitPath, LastDBFile , MLOMainFile, MLOFileDir
	 gosub, IniSave
return
	 
IniSave:
	IniWrite,%DialogHandler%,%IniFile%,Settings,DialogHandler
	IniWrite,%Scheduler%,%IniFile%,Settings,Scheduler
	IniWrite,%TrayNotifications%,%IniFile%,Settings,TrayNotifications
	IniWrite,%Tooltips%,%IniFile%,Settings,Tooltips
	IniWrite,%DoubleClickSpeed%,%IniFile%,Settings,DoubleClickSpeed
	IniWrite,%DialogHandlerDelay%,%IniFile%,Settings,DialogHandlerDelay
	IniWrite,%MaxItemsTopLevel%,%IniFile%,Settings,MaxItemsTopLevel
	IniWrite,%DueTasksStartToday%,%IniFile%,Settings,DueTasksStartToday
	IniWrite,%RestoreWindowAfterSnippet%,%IniFile%,Settings,RestoreWindowAfterSnippet
	IniWrite,%SnippetTaskName%,%IniFile%,Settings,SnippetTaskName
	IniWrite,%UpdateCheck%,%IniFile%,Settings,UpdateCheck

	IniWrite,%MLOFileDir%,%IniFile%,Settings,MLOFileDir
	IniWrite,%MLOMainFile%,%IniFile%,Settings,MLOMainFile
	IniWrite,%MLOFileList%,%IniFile%,Settings,MLOFileList
	IniWrite,%MLOsOpenHotkey%,%IniFile%,Settings,MLOsOpenHotkey
	IniWrite,%MLOsRapidTaskHotkey%,%IniFile%,Settings,MLOsRapidTaskHotkey
	
	IniWrite,%hk_ToggleMLO%,%IniFile%,Hotkeys,hk_ToggleMLO
	IniWrite,%hk_RapidTaskEntry%,%IniFile%,Hotkeys,hk_RapidTaskEntry
	IniWrite,%hk_SnippetToTask%,%IniFile%,Hotkeys,hk_SnippetToTask
	IniWrite,%hk_FavouriteParents%,%IniFile%,Hotkeys,hk_FavouriteParents
	IniWrite,%hk_CollapseExpandOutline%,%IniFile%,Hotkeys,hk_CollapseExpandOutline
	IniWrite,%hk_ExpandFirstLevelOutline%,%IniFile%,Hotkeys,hk_ExpandFirstLevelOutline
	IniWrite,%hk_ToggleZoom%,%IniFile%,Hotkeys,hk_ToggleZoom
	IniWrite,%hk_ToggleContexts%,%IniFile%,Hotkeys,hk_ToggleContexts
	IniWrite,%hk_SelectContexts1%,%IniFile%,Hotkeys,hk_SelectContexts1
	IniWrite,%hk_SelectContexts2%,%IniFile%,Hotkeys,hk_SelectContexts2
	IniWrite,%hk_ViewUp%,%IniFile%,Hotkeys,hk_ViewUp
	IniWrite,%hk_ViewDown%,%IniFile%,Hotkeys,hk_ViewDown
	IniWrite,%hk_PasteFileLinks%,%IniFile%,Hotkeys,hk_PasteFileLinks
	
	;IniWrite,%DueTasksStartTodayModifier%,%IniFile%,Hotkeys,DueTasksStartTodayModifier
	IniWrite,%hk_DueToday%,%IniFile%,Hotkeys,hk_DueToday
	IniWrite,%hk_DueTomo%,%IniFile%,Hotkeys,hk_DueTomo
	IniWrite,%hk_Due2Days%,%IniFile%,Hotkeys,hk_Due2Days
	IniWrite,%hk_Due3Days%,%IniFile%,Hotkeys,hk_Due3Days
	IniWrite,%hk_Due4Days%,%IniFile%,Hotkeys,hk_Due4Days
	IniWrite,%hk_Due5Days%,%IniFile%,Hotkeys,hk_Due5Days
	IniWrite,%hk_Due6Days%,%IniFile%,Hotkeys,hk_Due6Days
	IniWrite,%hk_Due7Days%,%IniFile%,Hotkeys,hk_Due7Days
	IniWrite,%hk_DueFriday%,%IniFile%,Hotkeys,hk_DueFriday
	IniWrite,%hk_DueNextFriday%,%IniFile%,Hotkeys,hk_DueNextFriday
	IniWrite,%hk_DueSunday%,%IniFile%,Hotkeys,hk_DueSunday
	IniWrite,%hk_DueNextSunday%,%IniFile%,Hotkeys,hk_DueNextSunday
	IniWrite,%hk_DueMonth%,%IniFile%,Hotkeys,hk_DueMonth
	
	IniWrite,%hk_PartialCompleteTask%,%IniFile%,Hotkeys,hk_PartialCompleteTask
	IniWrite,%hk_DetachRecurrentTask%,%IniFile%,Hotkeys,hk_DetachRecurrentTask
	IniWrite,%hk_CompletedYesterday1%,%IniFile%,Hotkeys,hk_CompletedYesterday1
	IniWrite,%hk_DueTodayThenComplete%,%IniFile%,Hotkeys,hk_DueTodayThenComplete
	IniWrite,%hk_SkipOccurence%,%IniFile%,Hotkeys,hk_SkipOccurence
	IniWrite,%hk_DecreaseDue%,%IniFile%,Hotkeys,hk_DecreaseDue
	IniWrite,%hk_IncreaseDue%,%IniFile%,Hotkeys,hk_IncreaseDue
	IniWrite,%hk_DecreaseStart%,%IniFile%,Hotkeys,hk_DecreaseStart
	IniWrite,%hk_IncreaseStart%,%IniFile%,Hotkeys,hk_IncreaseStart

	IniWrite,%NumSchedules%,%IniFile%,Schedules,NumSchedules
	loop, %NumSchedules%
	{
		thisname := Sched%a_index%
		IniWrite,%thisname%,%IniFile%,Schedules,Sched%a_index%
	}

	IniWrite,%NumFavs%,%IniFile%,FavouriteParents,NumFavs
	loop, %NumFavs%
	{
		thisname := Fav%a_index%
		IniWrite,%thisname%,%IniFile%,FavouriteParents,Fav%a_index%
	}
	FileSetAttrib, -A, %IniFile%
Return

PrepareTray:
	Menu,Tray,Tip, %TrayName%
	IfExist %A_ScriptDir%\%ScriptName%.ico
		Menu Tray,Icon, %A_ScriptDir%\%ScriptName%.ico
	Menu,Tray,Add

	Menu,Tray,DeleteAll
	Menu,Tray,icon
	Menu,tray,NoStandard

	Menu,Tray,Add,E&xit,Exit
	Menu,Tray,Add,&Reload,Reload
	Menu,Tray,Add,&Help,Help
	Menu,Tray,Add,&About,About
	Menu,Tray,Add,Check for Update,UpdateCheckManual
	Menu,Tray,Add
	If !A_IsCompiled
	{
	  Menu,Tray,Add,&List Lines,ListLines
	  Menu,Tray,Add,&AHK Help,AHKHelp
		Menu,Tray,Add,&Edit Script,Edit
		Menu,Tray,Default,&Edit Script
	}
	Menu,Tray,Add
	Menu,Tray,Add,&Save Ini,IniSave
	Menu,Tray,Add,&Load Ini,ReadIni
	Menu,Tray,Add,&Edit Ini,EditIni

	Menu,Settings,Add,Scheduler,SettingsMenuClicker
	Menu,Settings,Add,DialogHandler,SettingsMenuClicker
	Menu,Settings,Add,TrayNotifications,SettingsMenuClicker
	Menu,Settings,Add,Tooltips,SettingsMenuClicker
	Menu,Settings,Add,DueTasksStartToday,SettingsMenuClicker
	Menu,Settings,Add,RestoreWindowAfterSnippet,SettingsMenuClicker
	Menu,Settings,Add,UpdateCheck,SettingsMenuClicker
	Menu,Tray,add, Settings, :Settings
	Menu,Tray,Add

	If JonsComputer
	{
		;Menu,Tray,Add,NewDay,NewDay
		;Menu,Tray,Add
	}
	;Create menu items for each MLO file
	Loop, Parse, MLOFileList, `,
	{
		IfExist %MLOFileDir%\%A_LoopField%
			Menu, tray, add, %A_LoopField%, OpenFile
		;Menu, tray, default, %A_LoopField%
	}
	Menu,Tray,Add
	Menu,Tray,Add,MLO-Hotkeys,TryClk
	Menu,tray,Default,MLO-Hotkeys
	Menu,Tray,Add
	Menu,Tray,Add,MLO,ToggleMLO
	Menu,Tray,Add,Rapid Task,RapidTaskEntry
	Menu,Tray,Add,Rapid Task Favs,FavouriteParents
	Menu, Tray, Click, 1
	;Menu,Tray,Add,&MLO,ToggleMLO
	;Menu,Tray,Default,&MLO
Return

SettingsMenuChecker:
	If (Scheduler = 1)
		Menu, Settings, Check, Scheduler
	If (DialogHandler = 1)
		Menu, Settings, Check, DialogHandler
	If (TrayNotifications = 1)
		Menu, Settings, Check, TrayNotifications
	If (Tooltips = 1)
		Menu, Settings, Check, Tooltips
	If (DueTasksStartToday = 1)
		Menu, Settings, Check, DueTasksStartToday
	If (RestoreWindowAfterSnippet = 1)
		Menu, Settings, Check, RestoreWindowAfterSnippet
	If (UpdateCheck = 1)
		Menu, Settings, Check, UpdateCheck
Return

SettingsMenuClicker:
	Menu, %A_ThisMenu%, ToggleCheck, %A_ThisMenuItem%
	%A_ThisMenuItem% := (!%A_ThisMenuItem%)

	If (%a_thisMenuitem% = 1)
		Menu, %A_ThisMenu%, Check, %a_thisMenuitem%
	gosub, IniSave
Return

EditMLOHotkeys:
		WinActivate, ahk_class TfrmMyLifeMain
		WinWaitActive, ahk_class TfrmMyLifeMain,, 1
		ifwinactive, ahk_class TfrmMyLifeMain
		Send, {ALTDOWN}{ALTUP}{ALTDOWN}{ALTUP}oo{end}
return

ExitSub:
	ExitApp	; Must do this for the OnExit subroutine to actually Exit the script.
Return

ListLines:
	ListLines
Return

Edit:
	Edit
Return

EditIni:
	Run,%ScriptName%.ini
Return

OpenFile:
	Run,%MLOFileDir%\%a_thisMenuitem%
Return

ReadIni:
	Gosub, IniRead
	reload
Return

Reload:
	Gosub, IniSave
	Reload
Return

Exit:
	Gosub, IniSave
	ExitApp
Return


Help:
	Run, %A_ScriptDir%\ReadMe.txt
Return

AHKHelp:
	Run, %AHKPath%\AutoHotkey.chm
Return

About:
	MsgBox, %TrayName% v%Version% `nAutoHotkey Scripts for MyLife Organized`nby Jon Rumens`n%BuildDate%
Return



CheckReload:
;tooltip, %SnippetTaskName%
		filename = %ScriptName%.ini
		scriptpath = %A_ScriptDir%\%filename%
		FileGetAttrib, attribs, %scriptpath%

		IfInString, attribs, A
		{
			FileSetAttrib, -A, %scriptpath%
			SplashTextOn, , , Updated %filename%

			Sleep, 500
			SplashTextOff
			gosub, IniRead
			Reload
			Return
		}

	If (!A_IsCompiled)
	{
		filename = %ScriptName%.ahk
		scriptpath = %A_ScriptDir%\%filename%
		FileGetAttrib, attribs, %scriptpath%

		IfInString, attribs, A
		{
			FileSetAttrib, -A, %scriptpath%
			SplashTextOn, , , Updated %filename%

			Sleep, 500
			SplashTextOff
			Reload
			Return
		}
	}

Return

TrayTipOff:
	settimer, TrayTipOff, Off
	TrayTip
return

TooltipOff:				;*** Closes the standard ToolTip
	Thread, Priority, 1
	SetTimer, TooltipOff, Off
	ToolTip
Return


Scheduler:

	IfEqual, Scheduler, 1
	{
		loop, %NumSchedules%
		{
			thisname := Sched%a_index%
		  StringSplit, SchedArray, thisname, `, ;split into an array
	  	SchedHour := SchedArray1
	  	SchedMin := SchedArray2
			WeekDays := SchedArray3

			IfEqual, A_Hour, %SchedHour%
				IfEqual, A_Min, %SchedMin%
					IfInString, WeekDays, %A_WDay%
				{
      		LabelToRun := SchedArray4
				  tooltip, %thisname%
					SetTimer, TooltipOff, 3000
		  		gosub, %LabelToRun%
		  		sleep, %1min%
		  	}
		}
	}

Return

ShowContextMenu:
KeyWait, RButton
gosub, CheckIfPropsActive
SetDefaultMouseSpeed, 0
SetMouseDelay, 0
	MouseGetPos, mX, mY
	;ControlGetPos [, X, Y, Width, Height, Control, WinTitle, WinText, ExcludeTitle, ExcludeText]
	;ControlGetPos, cX, cY, cW, cH, TVirtualStringTree1
	ControlGetPos, cX, cY, cW, cH, TVirtualStringTree2
	cR := (cX+cW)
	cB := (cY+cH)
	If mX between %cX% and %cR%
	if mY between %cY% and %cB%
	{
		Menu, Context, add, MLO-Hotkeys..., dummy
		Menu, Context, disable, MLO-Hotkeys...
		Menu, Context, add, Skip Occurence `t%hk_SkipOccurence%, SkipOccurence
		Menu, Context, add, Partial Complete Task `t%hk_PartialCompleteTask%, PartialCompleteTask
		Menu, Context, add, Duplicate Task `t%hk_DuplicateTask%, DuplicateTask
		Menu, Context, add, Zoom `t%hk_ToggleZoom%, ToggleZoom
		Menu, Context, add,
		Menu, Context, add, Due Today `t%hk_DueToday%, DueToday
		Menu, Context, add, Due Tomo `t%hk_DueTomo%, DueTomo
		Menu, Context, add, Due 2 Days `t%hk_Due2Days%, Due2Days
		Menu, Context,add,Due 3 Days `t%hk_Due3Days%, Due3Days
		Menu, Context,add, Due Friday `t%hk_DueFriday%, DueFriday
		Menu, Context,add, Due Sunday `t%hk_DueSunday%, DueSunday
		Menu, Due, add, Due 2 Days `t%hk_Due2Days%, Due2Days
		Menu, Due,add,Due 3 Days `t%hk_Due3Days%, Due3Days
		Menu, Due,add,Due 4 Days `t%hk_Due4Days%, Due4Days
		Menu, Due,add,Due 5 Days `t%hk_Due5Days%, Due5Days
		Menu, Due,add,Due 6 Days `t%hk_Due6Days%, Due6Days
		Menu, Due,add,Due 1 Week `t%hk_Due7Days%, Due7Days
		Menu, Due,add, Due Next Friday `t%hk_DueNextFriday%, DueNextFriday
		Menu, Due,add, Due Next Sunday `t%hk_DueNextSunday%, DueNextSunday
		Menu, Due,add, Due 1 Month `t%hk_DueMonth%, DueMonth
		Menu, Due,add,
		
		loop, %NumFavs%
		{
			thispath := Fav%a_index%
			Menu, Move, add, %thispath%, MovetoFav
	  }
		
		Menu, Context, add, Due, :Due
		Menu, Context, add,
		if (NumFavs)
			Menu, Context, add, Move, :Move
		Menu, Context, add,
		Menu, Context, add, Due Date - `t%hk_DecreaseDue%, DecreaseDue
		Menu, Context, add, Due Date + `t%hk_IncreaseDue%, IncreaseDue
		Menu, Context, add, Start Date - `t%hk_DecreaseStart%, DecreaseStart
		Menu, Context, add, Start Date + `t%hk_IncreaseStart%, IncreaseStart
		Menu, Context, add,
		Menu, Context, add, Collapse/Expand Outline `t%hk_CollapseExpandOutline%, CollapseExpandOutline
		Menu, Context, add, Expand Outline 1st Level `t%hk_ExpandFirstLevelOutline%, ExpandFirstLevelOutline
		Menu, Context, add,
		Menu, Context, add, Detach Recurrent Task `t%hk_DetachRecurrentTask%, DetachRecurrentTask
		Menu, Context, add, Completed Task Yesterday `t%hk_CompletedYesterday1%, CompletedYesterday
		Menu, Context, add,
		Menu, Context, add, Add Favourite Parent, AddtoFavParent

		Menu, Context, show
		Menu, Context, Delete
		Menu, Due, Delete
		if (NumFavs > 1)
		Menu, Move, Delete

	}
	ControlGetPos, cX, cY, cW, cH, TMyRichEdit1
	cR := (cX+cW)
	cB := (cY+cH)
	If mX between %cX% and %cR%
	if mY between %cY% and %cB%
	{
		Menu, Context, add, Paste File Links, PasteFileLinks

		Menu, Context, show
		Menu, Context, Delete
}
	
return

dummy:
return


FavouriteParentsMenu:
path1 = %A_thismenuitem%
return

AddtoFavParent:
	WinWaitActive, ahk_class TfrmMyLifeMain
		controlgettext, path, TEdit6 ;get the current task path
		ifnotinstring, path, `\
			controlgettext, path, TEdit2 ;get the current task path
	controlgettext, taskname, TMemo1 ;get the current task path
	NumFavs ++
	Fav%NumFavs% = %taskparent%%taskname%
	gosub, IniSave
	tooltip, "%taskparent%%taskname%" has been added to Favourite Parents.
		settimer, ToolTipOff, 3000
return


MovetoFav:

path1 =
path1 = %A_thismenuitem%
	WinWaitActive, ahk_class TfrmMyLifeMain

	ifequal, path1, %blank%
	return

	StringTrimLeft, path1, path1, 1 ;get rid of first backslash
	;StringTrimRight, path1, path1, 1 ;get rid of last backslash
;msgbox, %path1%

	StringSplit, pathArray, path1, `\ ;split the path into an array

send, !o
send, ^m
winwaitactive, ahk_class TfrmSelectTaskNode
	;msgbox, %pathArray0% %pathArray1% %pathArray2%
	send, {home} ;go to top of select task list
	Loop, %pathArray0% ;send the path one by one
	{
	    thistask := pathArray%a_index%
	    ;msgbox, %pathArray0% %thistask%
	    send, %thistask%
	    send, {up}{down}
	}
	send, {enter}

return

ViewUp:
gosub, CheckIfToDoActive
if (ToDo = 1)
	send !v{up}{enter}
return

ViewDown:
gosub, CheckIfToDoActive
if (ToDo = 1)
	send !v{down}{enter}
return


UpdateCheckManual:
	;msgbox, http://www.jonrumens.com/versions/%ScriptName%.txt
	FileDelete,%A_WorkingDir%\LatestVersion.txt
	;FileAppend, %Version%, CurrentVersion.txt
	URLDownloadToFile,http://www.jonrumens.com/versions/%ScriptName%.txt,%A_WorkingDir%\LatestVersion.txt
	;run, %A_WorkingDir%\VersionCheck.txt
	If ErrorLevel = 0
	{
		FileReadLine, Latest, %A_WorkingDir%\LatestVersion.txt,1
		If Latest != %Version%
		{
			MsgBox,4,%AppName% v%Version%, %AppName% v%Latest% is available! `nDownload now?
			IfMsgBox,Yes
				Run, http://www.jonrumens.com/%ScriptName%.zip
		}
		else
		{
			MsgBox,0,%AppName% v%Version%, %AppName% is up to date!
		}
		FileDelete,%A_WorkingDir%\LatestVersion.txt
	}
Return



UpdateCheck:
	SetTimer,UpdateCheck,Off
	;msgbox, http://www.jonrumens.com/%ScriptName%/CurrentVersion.txt
	FileDelete,%A_WorkingDir%\LatestVersion.txt
	;FileAppend, %Version%, CurrentVersion.txt
	URLDownloadToFile,http://www.jonrumens.com/versions/%ScriptName%.txt,%A_WorkingDir%\LatestVersion.txt
	;run, %A_WorkingDir%\VersionCheck.txt
	If ErrorLevel = 0
	{
		FileReadLine, Latest, %A_WorkingDir%\LatestVersion.txt,1
		If Latest != %Version%
		{
			MsgBox,4,%AppName% v%Version%, %AppName% v%Latest% is available! `nDownload now?
			IfMsgBox,Yes
				Run, http://www.jonrumens.com/%ScriptName%.zip
		}
		FileDelete,%A_WorkingDir%\LatestVersion.txt
	}
Return